#! /usr/bin/perl -w

# This perl script will change the conf/defaults
# file, so that new devices could be added into
# SPICE3f5 afterwards
#
# Usage:
# install.pl devicename defaultsfile
#
# July 8, 2003
# Bo Hu hubo@ee.washington.edu
# Electrical Engineering Department
# The University of Washington
#
if( $#ARGV < 1 )
{ die "***input format error***\nUsage: \n     install.pl devicename filename\nProgram exits\n";}
$dev  = $ARGV[0];
$defaults = $ARGV[1];
$output = $defaults . ".new";

open(FIN,$defaults) or die "cannot open file $defaults\n";
open(FOUT,">$output") or die "cannot write file $output\n";

while(<FIN>)
{
  chomp;
  $line = $_;
  if($line =~ /^DEVICES\s+=/)
  {
    $tmpline = $line;
    #read in all the lines belonging to DEVICES
    while($tmpline =~ /\\/) #found the '\' symbol, read next line
    {
      $tmpline = <FIN>;
      chomp $tmpline;
      $line = $line . $tmpline;
    }
    if($line =~ /\b$dev\b/)#the device is already there, do nothing
    {
     close FIN;close FOUT;unlink $output;
     die "the device $dev already exists, program exit.\n";
    }
    else
    {
      #add the device at the end of $line;
      $line = $line . " $dev" ;
      $line =~ s/\\/\\\n/g;
    #  print "device is:$dev\nline is:\n$line\n";
      print FOUT "$line\n";
    }
  }
  else
  {
    print FOUT "$line\n";
    next;
  }

}
close FIN;
close FOUT;
unlink $defaults;
rename $output, $defaults;
print STDERR "$defaults has been updated\n";
