/**********
Copyright 1990 Regents of the University of California.  All rights reserved.
Author: 1985 Thomas L. Quarles
**********/
/*
 */

#include "spice.h"
#include <stdio.h>
#include "util.h"
#include "cktdefs.h"
#include "opampdefs.h"
#include "trandefs.h"
#include "sperror.h"
#include "suffix.h"


int
OPAMPfindBr(ckt,inModel,name)
    register CKTcircuit *ckt;
    GENmodel *inModel;
    register IFuid name;
{
    register OPAMPmodel *model = (OPAMPmodel *)inModel;
    register OPAMPinstance *here;
    int error;
    CKTnode *tmp;

    for( ; model != NULL; model = model->OPAMPnextModel) {
        for (here = model->OPAMPinstances; here != NULL;
                here = here->OPAMPnextInstance) {
            if(here->OPAMPname == name) {
                if(here->OPAMPinode == 0) {
                    error = CKTmkCur(ckt,&tmp,here->OPAMPname,"inode");
                    if(error) return(error);
                    here->OPAMPinode = tmp->number;
                }
                return(here->OPAMPinode);
            }
        }
    }
    return(0);
}
